////////////////////////////////////////////////////////////////////////
// edit_user.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.edit_user")

// <%pre>
#line 1 "edit_user.ecpp"


#include <users.h>
#include <livefeatures.h>
#include <setup.h>

using namespace vdrlive;


#line 1 "page_init.eh"

// do not add to Makefile
// and do not write a ecpp comment into this file. It must produce no
// html output not even an empty line.
#include <tnt/savepoint.h>
#include <exception.h>

#line 2 "page_exit.eh"

#include <exception.h>

// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
};

static tnt::EcppComponentFactoryImpl<_component_> Factory("edit_user");

static const char* rawData = "\234\000\000\000\t\001\000\000\024\001\000\000\027\001\000\000]\001\000\000`\001\000\000"
  "\347\001\000\000\246\002\000\000\014\003\000\000^\003\000\000\316\003\000\000$\004\000\000\256\004\000\000\023\005"
  "\000\0008\005\000\000\201\005\000\000\246\005\000\000\357\005\000\000\024\006\000\000[\006\000\000~\006\000\000\307"
  "\006\000\000\354\006\000\0007\007\000\000^\007\000\000\250\007\000\000\316\007\000\000\333\007\000\000\030\010\000"
  "\000>\010\000\000\210\010\000\000\256\010\000\000\273\010\000\000\366\010\000\000\032\t\000\000\345\t\000\0001\n\000"
  "\000\222\n\000\000\223\n\000\000\n<html>\n\t<head>\n\t\t<meta name=\"viewport\" content=\"width=device-width, initial"
  "-scale=1\" />\n\t\t<title>VDR Live - </title>\n\t\t\n\t\t\n\t</head>\n\t<body onload=\"adjustHeader()\" onresize=\"ad"
  "justHeader()\">\n\t\t\n\t\t\n\t\t<div class=\"inhalt\">\n\t\t\t<form method=\"post\" name=\"edit_user\" action=\"edit"
  "_user.ecpp\">\n\t\t\t\t<input type=\"hidden\" name=\"userid\" value=\"\"/>\n\t\t\t\t<table class=\"formular\" cellpad"
  "ding=\"0\" cellspacing=\"0\">\n\t\t\t\t\t<tr class=\"head\">\n\t\t\t\t\t\t<td class=\"toprow leftcol rightcol\" colsp"
  "an=\"2\"><div class=\"boxheader\"><div><div class=\"caption\"></div></div></div></td>\n\t\t\t\t\t</tr>\n\n\t\t\t\t\t<"
  "tr>\n\t\t\t\t\t\t<td class=\"label leftcol\"><div class=\"withmargin\">:</div></td>\n\t\t\t\t\t\t<td class=\"rightcol"
  "\"><input type=\"text\" name=\"username\" value=\"\" class=\"width99\" size=\"55\"/></td>\n\t\t\t\t\t</tr>\n\t\t\t\t"
  "\t<tr>\n\t\t\t\t\t\t<td class=\"label leftcol\"><div class=\"withmargin\">:</div></td>\n\t\t\t\t\t\t<td class=\"right"
  "col\"><input type=\"password\" name=\"password\" value=\"\" class=\"width99\" size=\"55\"/></td>\n\t\t\t\t\t</tr>\n\t"
  "\t\t\t\t<!-- user rights -->\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class=\"label leftcol\"><div class=\"withmargin\">:</di"
  "v></td>\n\t\t\t\t\t\t<td class=\"rightcol\">\n\t\t\t\t\t\t\t<input type=\"checkbox\" name=\"ur_editsetup\" value=\"1"
  "\"  />\n\t\t\t\t\t\t\t<label for=\"ur_editsetup\"></label><br>\n\t\t\t\t\t\t\t<input type=\"checkbox\" name=\"ur_addt"
  "imers\" value=\"1\"  />\n\t\t\t\t\t\t\t<label for=\"ur_addtimers\"></label><br>\n\t\t\t\t\t\t\t<input type=\"checkbox"
  "\" name=\"ur_deltimers\" value=\"1\"  />\n\t\t\t\t\t\t\t<label for=\"ur_deltimers\"></label><br>\n\t\t\t\t\t\t\t<inpu"
  "t type=\"checkbox\" name=\"ur_delrecs\" value=\"1\"  />\n\t\t\t\t\t\t\t<label for=\"ur_delrecs\"></label><br>\n\t\t\t"
  "\t\t\t\t<input type=\"checkbox\" name=\"ur_useremote\" value=\"1\"  />\n\t\t\t\t\t\t\t<label for=\"ur_useremote\"></l"
  "abel><br>\n\t\t\t\t\t\t\t<input type=\"checkbox\" name=\"ur_startreplay\" value=\"1\"  />\n\t\t\t\t\t\t\t<label for="
  "\"ur_startreplay\"></label><br>\n\t\t\t\t\t\t\t<input type=\"checkbox\" name=\"ur_switchchnl\" value=\"1\"  />\n\t\t"
  "\t\t\t\t\t<label for=\"ur_switchchnl\"></label><br>\n\t\t\t\t\t\t\t<input type=\"checkbox\" name=\"ur_addstimers\" va"
  "lue=\"1\"  />\n\t\t\t\t\t\t\t<label for=\"ur_addstimers\"></label><br>\n\t\t\t\t\t\t\t<input type=\"checkbox\" name="
  "\"ur_delstimers\" value=\"1\"  />\n\t\t\t\t\t\t\t<label for=\"ur_delstimers\"></label><br>\n\t\t\t\t\t\t\t<input type"
  "=\"checkbox\" name=\"ur_editrecs\" value=\"1\"  />\n\t\t\t\t\t\t\t<label for=\"ur_editrecs\"></label><br>\n\t\t\t\t\t"
  "\t</td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class=\"buttonpanel leftcol rightcol bottomrow\" colspan=\""
  "2\">\n\t\t\t\t\t\t\t<div class=\"withmargin\">\n\t\t\t\t\t\t\t<button class=\"green\" type=\"submit\" name=\"save\"><"
  "/button>\n\t\t\t\t\t\t\t<button type=\"button\" class=\"red\" onclick=\"history.back()\"></button>\n\t\t\t\t\t\t\t</d"
  "iv>\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\t\t\t\t</table>\n\t\t\t</form>\n\t\t</div>\n\t</body>\n</html>\n\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl)
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

template <typename T>
inline void _tnt_ignore_unused(const T&) { }

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("edit_user " << qparam.getUrl());

  tnt::DataChunks _tntChunks(rawData);

  // <%args>
std::string userid = qparam.get< std::string >("userid");
std::string username = qparam.get< std::string >("username");
std::string password = qparam.get< std::string >("password");
bool ur_editsetup = qparam.get< bool >("ur_editsetup", ( false));
bool ur_addtimers = qparam.get< bool >("ur_addtimers", ( false));
bool ur_deltimers = qparam.get< bool >("ur_deltimers", ( false));
bool ur_delrecs = qparam.get< bool >("ur_delrecs", ( false));
bool ur_useremote = qparam.get< bool >("ur_useremote", ( false));
bool ur_startreplay = qparam.get< bool >("ur_startreplay", ( false));
bool ur_switchchnl = qparam.get< bool >("ur_switchchnl", ( false));
bool ur_addstimers = qparam.get< bool >("ur_addstimers", ( false));
bool ur_delstimers = qparam.get< bool >("ur_delstimers", ( false));
bool ur_editrecs = qparam.get< bool >("ur_editrecs", ( false));
  // </%args>

#line 28 "edit_user.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 31 "edit_user.ecpp"
  typedef cUser* editUser_type;
  TNT_REQUEST_PAGE_VAR(cUser*, editUser, ());   // <%request> cUser* editUser
  _tnt_ignore_unused<editUser_type>(editUser);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  // <%include> page_init.eh
#line 11 "page_init.eh"

try {
	reply.setHeader("Expires", "Mon, 26 Jul 1997 05:00:00 GMT");
	tnt::Savepoint spoint( reply );

  // </%include>
#line 34 "edit_user.ecpp"

	if (!logged_in && LiveSetup().UseAuth()) return reply.redirect("login.html");

#define CHECKIF(x) reply.out() << ( (x) ? "checked=\"checked\"" : "" );

	editUser = NULL;

	if (request.getMethod() == "POST") {
		if (!userid.empty()) {
			editUser = Users.GetByUserId( userid );
			if ( editUser == 0 )
				throw HtmlError( tr("Couldn't find user. Maybe you mistyped your request?") );
			editUser->SetName(username);
			if (password != std::string(editUser->GetPasswordLength(), '*'))
				editUser->SetPassword(password);
		}
		else
		{
			if (Users.GetByUserName( username ))
				throw HtmlError( tr("This user name is already in use!") );
			editUser = new cUser(Users.GetNewId(), username, password);
			Users.Add(editUser);
		}
		editUser->SetUserrights(0);
		if (ur_editsetup) editUser->SetRight(UR_EDITSETUP);
		if (ur_addtimers) editUser->SetRight(UR_EDITTIMERS);
		if (ur_deltimers) editUser->SetRight(UR_DELTIMERS);
		if (ur_delrecs) editUser->SetRight(UR_DELRECS);
		if (ur_useremote) editUser->SetRight(UR_USEREMOTE);
		if (ur_startreplay) editUser->SetRight(UR_STARTREPLAY);
		if (ur_switchchnl) editUser->SetRight(UR_SWITCHCHNL);
		if (ur_addstimers) editUser->SetRight(UR_EDITSTIMERS);
		if (ur_delstimers) editUser->SetRight(UR_DELSTIMERS);
		if (ur_editrecs) editUser->SetRight(UR_EDITRECS);

		Users.Save();

		return reply.redirect("users.html");
	}

	pageTitle = !userid.empty() ? tr("Edit user") : tr("New user");

	if (  !userid.empty() ) {
		cUser* User = Users.GetByUserId( userid );
		if ( User == 0 )
			throw HtmlError( tr("Couldn't find user. Maybe you mistyped your request?") );

		username = User->Name();
		password = std::string(User->GetPasswordLength(), '*');
		ur_editsetup = User->HasRightTo(UR_EDITSETUP);
		ur_addtimers = User->HasRightTo(UR_EDITTIMERS);
		ur_deltimers = User->HasRightTo(UR_DELTIMERS);
		ur_delrecs = User->HasRightTo(UR_DELRECS);
		ur_useremote = User->HasRightTo(UR_USEREMOTE);
		ur_startreplay = User->HasRightTo(UR_STARTREPLAY);
		ur_switchchnl = User->HasRightTo(UR_SWITCHCHNL);
		ur_addstimers = User->HasRightTo(UR_EDITSTIMERS);
		ur_delstimers = User->HasRightTo(UR_DELSTIMERS);
		ur_editrecs = User->HasRightTo(UR_EDITRECS);
		editUser = User;
	}
	else
	{
		ur_editsetup = true;
		ur_addtimers = true;
		ur_deltimers = true;
		ur_delrecs = true;
		ur_useremote = true;
		ur_startreplay = true;
		ur_switchchnl = true;
		ur_addstimers = true;
		ur_delstimers = true;
		ur_editrecs = true;
	}

  // <& pageelems.doc_type ...
  { 
#line 109 "edit_user.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 109 "edit_user.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "doc_type"), request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << _tntChunks[0]; // \n<html>\n\t<head>\n\t\t<meta name="viewport" content="width=device-width, initial-scale=1" />\n\t\t<title>VDR Live - 
#line 113 "edit_user.ecpp"
  reply.sout() << ( pageTitle );
  reply.out() << _tntChunks[1]; // </title>\n\t\t
  // <& pageelems.stylesheets ...
  { 
#line 114 "edit_user.ecpp"
    tnt::QueryParams _tnt_cq1;
#line 114 "edit_user.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "stylesheets"), request, reply, _tnt_cq1);
    // &>
  }
  reply.out() << _tntChunks[2]; // \n\t\t
  // <& pageelems.ajax_js ...
  { 
#line 115 "edit_user.ecpp"
    tnt::QueryParams _tnt_cq2;
#line 115 "edit_user.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_js"), request, reply, _tnt_cq2);
    // &>
  }
  reply.out() << _tntChunks[3]; // \n\t</head>\n\t<body onload="adjustHeader()" onresize="adjustHeader()">\n\t\t
  // <& pageelems.logo ...
  { 
#line 118 "edit_user.ecpp"
    tnt::QueryParams _tnt_cq3;
#line 118 "edit_user.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "logo"), request, reply, _tnt_cq3);
    // &>
  }
  reply.out() << _tntChunks[4]; // \n\t\t
  // <& menu ...
  { 
#line 119 "edit_user.ecpp"
    tnt::QueryParams _tnt_cq4;
#line 119 "edit_user.ecpp"
    _tnt_cq4.add( "active", ("users"));
#line 119 "edit_user.ecpp"
    callComp(tnt::Compident(std::string(), "menu"), request, reply, _tnt_cq4);
    // &>
  }
  reply.out() << _tntChunks[5]; // \n\t\t<div class="inhalt">\n\t\t\t<form method="post" name="edit_user" action="edit_user.ecpp">\n\t\t\t\t<input type="hidden" name="userid" value="
#line 122 "edit_user.ecpp"
  reply.sout() << ( userid );
  reply.out() << _tntChunks[6]; // "/>\n\t\t\t\t<table class="formular" cellpadding="0" cellspacing="0">\n\t\t\t\t\t<tr class="head">\n\t\t\t\t\t\t<td class="toprow leftcol rightcol" colspan="2"><div class="boxheader"><div><div class="caption">
#line 125 "edit_user.ecpp"
  reply.sout() << ( pageTitle );
  reply.out() << _tntChunks[7]; // </div></div></div></td>\n\t\t\t\t\t</tr>\n\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 129 "edit_user.ecpp"
  reply.sout() << ( tr("Name" ) );
  reply.out() << _tntChunks[8]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol"><input type="text" name="username" value="
#line 130 "edit_user.ecpp"
  reply.sout() << ( username );
  reply.out() << _tntChunks[9]; // " class="width99" size="55"/></td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 133 "edit_user.ecpp"
  reply.sout() << ( tr("Password" ) );
  reply.out() << _tntChunks[10]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol"><input type="password" name="password" value="
#line 134 "edit_user.ecpp"
  reply.sout() << ( password );
  reply.out() << _tntChunks[11]; // " class="width99" size="55"/></td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<!-- user rights -->\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 138 "edit_user.ecpp"
  reply.sout() << ( tr("User rights") );
  reply.out() << _tntChunks[12]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol">\n\t\t\t\t\t\t\t<input type="checkbox" name="ur_editsetup" value="1" 
#line 140 "edit_user.ecpp"
 CHECKIF(ur_editsetup) 
  reply.out() << _tntChunks[13]; //  />\n\t\t\t\t\t\t\t<label for="ur_editsetup">
#line 141 "edit_user.ecpp"
  reply.sout() << ( tr("Edit setup") );
  reply.out() << _tntChunks[14]; // </label><br>\n\t\t\t\t\t\t\t<input type="checkbox" name="ur_addtimers" value="1" 
#line 142 "edit_user.ecpp"
 CHECKIF(ur_addtimers) 
  reply.out() << _tntChunks[15]; //  />\n\t\t\t\t\t\t\t<label for="ur_addtimers">
#line 143 "edit_user.ecpp"
  reply.sout() << ( tr("Add or edit timers") );
  reply.out() << _tntChunks[16]; // </label><br>\n\t\t\t\t\t\t\t<input type="checkbox" name="ur_deltimers" value="1" 
#line 144 "edit_user.ecpp"
 CHECKIF(ur_deltimers) 
  reply.out() << _tntChunks[17]; //  />\n\t\t\t\t\t\t\t<label for="ur_deltimers">
#line 145 "edit_user.ecpp"
  reply.sout() << ( tr("Delete timers") );
  reply.out() << _tntChunks[18]; // </label><br>\n\t\t\t\t\t\t\t<input type="checkbox" name="ur_delrecs" value="1" 
#line 146 "edit_user.ecpp"
 CHECKIF(ur_delrecs) 
  reply.out() << _tntChunks[19]; //  />\n\t\t\t\t\t\t\t<label for="ur_delrecs">
#line 147 "edit_user.ecpp"
  reply.sout() << ( tr("Delete recordings") );
  reply.out() << _tntChunks[20]; // </label><br>\n\t\t\t\t\t\t\t<input type="checkbox" name="ur_useremote" value="1" 
#line 148 "edit_user.ecpp"
 CHECKIF(ur_useremote) 
  reply.out() << _tntChunks[21]; //  />\n\t\t\t\t\t\t\t<label for="ur_useremote">
#line 149 "edit_user.ecpp"
  reply.sout() << ( tr("Use remote menu") );
  reply.out() << _tntChunks[22]; // </label><br>\n\t\t\t\t\t\t\t<input type="checkbox" name="ur_startreplay" value="1" 
#line 150 "edit_user.ecpp"
 CHECKIF(ur_startreplay) 
  reply.out() << _tntChunks[23]; //  />\n\t\t\t\t\t\t\t<label for="ur_startreplay">
#line 151 "edit_user.ecpp"
  reply.sout() << ( tr("Start replay") );
  reply.out() << _tntChunks[24]; // </label><br>\n\t\t\t\t\t\t\t<input type="checkbox" name="ur_switchchnl" value="1" 
#line 152 "edit_user.ecpp"
 CHECKIF(ur_switchchnl) 
  reply.out() << _tntChunks[25]; //  />\n\t\t\t\t\t\t\t<label for="ur_switchchnl">
#line 153 "edit_user.ecpp"
  reply.sout() << ( tr("Switch channel") );
  reply.out() << _tntChunks[26]; // </label><br>\n
#line 154 "edit_user.ecpp"

							if (LiveFeatures<features::epgsearch>().Recent()) {

  reply.out() << _tntChunks[27]; // \t\t\t\t\t\t\t<input type="checkbox" name="ur_addstimers" value="1" 
#line 157 "edit_user.ecpp"
 CHECKIF(ur_addstimers) 
  reply.out() << _tntChunks[28]; //  />\n\t\t\t\t\t\t\t<label for="ur_addstimers">
#line 158 "edit_user.ecpp"
  reply.sout() << ( tr("Add or edit search timers") );
  reply.out() << _tntChunks[29]; // </label><br>\n\t\t\t\t\t\t\t<input type="checkbox" name="ur_delstimers" value="1" 
#line 159 "edit_user.ecpp"
 CHECKIF(ur_delstimers) 
  reply.out() << _tntChunks[30]; //  />\n\t\t\t\t\t\t\t<label for="ur_delstimers">
#line 160 "edit_user.ecpp"
  reply.sout() << ( tr("Delete search timers") );
  reply.out() << _tntChunks[31]; // </label><br>\n
#line 161 "edit_user.ecpp"

							}

  reply.out() << _tntChunks[32]; // \t\t\t\t\t\t\t<input type="checkbox" name="ur_editrecs" value="1" 
#line 164 "edit_user.ecpp"
 CHECKIF(ur_editrecs) 
  reply.out() << _tntChunks[33]; //  />\n\t\t\t\t\t\t\t<label for="ur_editrecs">
#line 165 "edit_user.ecpp"
  reply.sout() << ( tr("Edit recordings") );
  reply.out() << _tntChunks[34]; // </label><br>\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="buttonpanel leftcol rightcol bottomrow" colspan="2">\n\t\t\t\t\t\t\t<div class="withmargin">\n\t\t\t\t\t\t\t<button class="green" type="submit" name="save">
#line 171 "edit_user.ecpp"
  reply.sout() << ( tr("Save") );
  reply.out() << _tntChunks[35]; // </button>\n\t\t\t\t\t\t\t<button type="button" class="red" onclick="history.back()">
#line 172 "edit_user.ecpp"
  reply.sout() << ( tr("Cancel") );
  reply.out() << _tntChunks[36]; // </button>\n\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\t\t\t\t</table>\n\t\t\t</form>\n\t\t</div>\n\t</body>\n</html>\n
  // <%include> page_exit.eh
  reply.out() << _tntChunks[37]; // \n
#line 5 "page_exit.eh"

	spoint.commit();
} catch ( vdrlive::HtmlError const& ex ) {
	tnt::QueryParams param = qparam;
	param.add( "pageTitle", pageTitle );
	param.add( "errorMessage", ex.what() );
	callComp( "error", request, reply, param );
}

  // </%include>
  // <%/cpp>
  return DEFAULT;
}

} // namespace
