////////////////////////////////////////////////////////////////////////
// timerconflicts.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.timerconflicts")

// <%pre>
#line 1 "timerconflicts.ecpp"


#include <timerconflict.h>
#include <tools.h>
#include <setup.h>
#include <epg_events.h>
#include <timers.h>

using namespace vdrlive;


#line 1 "page_init.eh"

// do not add to Makefile
// and do not write a ecpp comment into this file. It must produce no
// html output not even an empty line.
#include <tnt/savepoint.h>
#include <exception.h>

#line 2 "page_exit.eh"

#include <exception.h>

// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
};

static tnt::EcppComponentFactoryImpl<_component_> Factory("timerconflicts");

static const char* rawData = "\000\001\000\000m\001\000\000x\001\000\000{\001\000\000\301\001\000\000\304\001\000\000"
  "\334\001\000\000\340\001\000\000\341\001\000\000\034\002\000\000w\002\000\000\230\002\000\000\232\002\000\000{\003"
  "\000\000\252\003\000\000\331\003\000\000\010\004\000\0007\004\000\000f\004\000\000\023\006\000\000:\006\000\000F\006"
  "\000\000O\006\000\000o\006\000\000\250\006\000\000\252\006\000\000\315\006\000\000\356\006\000\000\015\007\000\000."
  "\007\000\000M\007\000\000g\007\000\000\206\007\000\000\243\007\000\000\254\007\000\000\255\007\000\000\266\007\000"
  "\000\332\007\000\000\365\007\000\000\377\007\000\000\013\010\000\000B\010\000\000D\010\000\000T\010\000\000n\010\000"
  "\000\230\010\000\000\244\010\000\000\255\010\000\000\330\010\000\000\367\010\000\000\021\t\000\000\032\t\000\000E\t"
  "\000\000G\t\000\000p\t\000\000\217\t\000\000\251\t\000\000\262\t\000\000\320\t\000\000\027\n\000\000#\n\000\000=\n"
  "\000\000>\n\000\000@\n\000\000\n<html>\n\t<head>\n\t\t<meta name=\"viewport\" content=\"width=device-width, initial-s"
  "cale=1\" />\n\t\t<title>VDR-Live - </title>\n\t\t\n\t\t\n\t</head>\n\t<body onload=\"adjustHeader()\" onresize=\"adju"
  "stHeader()\">\n\t\t\n\t\t\n\t\t<div class=\"inhalt\">\n\t\t\t\t\n\t\t\t<table class=\"listing\" cellspacing=\"0\" cel"
  "lpadding=\"0\">\n\t\t\t\t\t\t<tr class=\"head\">\n\t\t\t\t\t\t\t<td colspan=\"11\">\n\t\t\t\t\t\t\t\t <div class=\"bo"
  "xheader\"><div><div><span style=\"float:right;\"><diff>:  </diff></span></div></div></div>\n\t\t\t\t\t\t\t</td>\n\t\t"
  "\t\t\t\t</tr>\n\t\t\t\t\t\t<tr class=\"description\">\n\t\t\t\t\t\t\t<td class=\"leftcol\"><img src=\"img/transparent"
  ".png\" alt=\"\" width=\"16px\" height=\"16px\" /></td>\n\t\t\t\t\t\t\t<td><div class=\"withmargin\"></div></td>\n\t\t"
  "\t\t\t\t\t<td><div class=\"withmargin\"></div></td>\n\t\t\t\t\t\t\t<td><div class=\"withmargin\"></div></td>\n\t\t\t"
  "\t\t\t\t<td><div class=\"withmargin\"></div></td>\n\t\t\t\t\t\t\t<td><div class=\"withmargin\"></div></td>\n\t\t\t\t"
  "\t\t\t<td><div class=\"withmargin\"></div></td>\n\t\t\t\t\t\t\t<td class=\"action\"><img src=\"img/transparent.png\" "
  "alt=\"\" width=\"16px\" height=\"16px\" /></td>\n\t\t\t\t\t\t\t<td class=\"action\"><img src=\"img/transparent.png\" "
  "alt=\"\" width=\"16px\" height=\"16px\" /></td>\n\t\t\t\t\t\t\t<td class=\"action\"><img src=\"img/transparent.png\" "
  "alt=\"\" width=\"16px\" height=\"16px\" /></td>\n\t\t\t\t\t\t\t<td class=\"action rightcol\"><img src=\"img/transpare"
  "nt.png\" alt=\"\" width=\"16px\" height=\"16px\" /></td>\n\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td "
  "class=\"leftcol \"><img src=\"\" alt=\"\" ></img></td>\n\t\t\t\t\t\t\t\t<td class=\"\"><div class=\"withmargin\"><a h"
  "ref=\"schedule.html\?channel=\"></a></div></td>\n\t\t\t\t\t\t\t\t<td class=\"\"><div class=\"withmargin nowrap\"></di"
  "v></td>\n\t\t\t\t\t\t\t\t<td class=\"\"><div class=\"withmargin nowrap\"></div></td>\n\t\t\t\t\t\t\t\t<td class=\"\">"
  "<div class=\"withmargin\"></div></td>\n\t\t\t\t\t\t\t\t<td class=\"\"><div class=\"withmargin\"><a\n\t\t\t\t\t\t\t\t"
  "\t\n\t\t\t\t\t\t\t\t></a></div></td>\n\n\t\t\t\t\t\t\t\t<td class=\"\"><div class=\"withmargin\">\n\t\t\t\t\t\t\t\t  "
  "</div></td>\n\t\t\t\t\t\t\t\t  <a href=\"edit_searchtimer.html\?searchtimerid=\"></a></div></td>\n\t\t\t\t\t\t\t\t<td"
  " class=\"action \"><a href=\"searchresults.html\?searchplain=\"><img src=\"\" alt=\"\" ></img></a></td>\n\t\t\t\t\t\t"
  "\t\t<td class=\"action \"><a href=\"timers.html\?timerid=&action=toggle\"><img src=\"\" alt=\"\" ></img></a></td>\n\t"
  "\t\t\t\t\t\t\t<td class=\"action \"></td>\n\t\t\t\t\t\t\t\t<td class=\"action rightcol \"><a href=\"timers.html\?time"
  "rid=&action=delete\"><img src=\"\" alt=\"\" ></img></a></td>\n\t\t\t\t\t\t\t</tr>\n</%cpp\n\t\t\t\t\t\t<tr class=\"sp"
  "acer\">\n\t\t\t\t\t\t\t<td colspan=\"10\"/>\n\t\t\t\t\t\t</tr>\n\t\t\t</table>\n\t\t</div>\n\t</body>\n</html>\n\n\n"
  "\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl)
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

template <typename T>
inline void _tnt_ignore_unused(const T&) { }

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("timerconflicts " << qparam.getUrl());

  tnt::DataChunks _tntChunks(rawData);

#line 16 "timerconflicts.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  // <%include> page_init.eh
#line 11 "page_init.eh"

try {
	reply.setHeader("Expires", "Mon, 26 Jul 1997 05:00:00 GMT");
	tnt::Savepoint spoint( reply );

  // </%include>
#line 19 "timerconflicts.ecpp"

if (!logged_in && LiveSetup().UseAuth()) return reply.redirect("login.html");

#line 22 "timerconflicts.ecpp"

	pageTitle = tr("Timer conflicts");
	TimerConflicts timerConflicts;
	cMutexLock timersLock( &LiveTimerManager() );
	SortedTimers& timers = LiveTimerManager().GetTimers();

  // <& pageelems.doc_type ...
  { 
#line 28 "timerconflicts.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 28 "timerconflicts.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "doc_type"), request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << _tntChunks[0]; // \n<html>\n\t<head>\n\t\t<meta name="viewport" content="width=device-width, initial-scale=1" />\n\t\t<title>VDR-Live - 
#line 32 "timerconflicts.ecpp"
  reply.sout() << ( pageTitle );
  reply.out() << _tntChunks[1]; // </title>\n\t\t
  // <& pageelems.stylesheets ...
  { 
#line 33 "timerconflicts.ecpp"
    tnt::QueryParams _tnt_cq1;
#line 33 "timerconflicts.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "stylesheets"), request, reply, _tnt_cq1);
    // &>
  }
  reply.out() << _tntChunks[2]; // \n\t\t
  // <& pageelems.ajax_js ...
  { 
#line 34 "timerconflicts.ecpp"
    tnt::QueryParams _tnt_cq2;
#line 34 "timerconflicts.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_js"), request, reply, _tnt_cq2);
    // &>
  }
  reply.out() << _tntChunks[3]; // \n\t</head>\n\t<body onload="adjustHeader()" onresize="adjustHeader()">\n\t\t
  // <& pageelems.logo ...
  { 
#line 37 "timerconflicts.ecpp"
    tnt::QueryParams _tnt_cq3;
#line 37 "timerconflicts.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "logo"), request, reply, _tnt_cq3);
    // &>
  }
  reply.out() << _tntChunks[4]; // \n\t\t
  // <& menu ...
  { 
#line 38 "timerconflicts.ecpp"
    tnt::QueryParams _tnt_cq4;
#line 38 "timerconflicts.ecpp"
    _tnt_cq4.add( "active", ("timersconflicts"));
#line 38 "timerconflicts.ecpp"
    callComp(tnt::Compident(std::string(), "menu"), request, reply, _tnt_cq4);
    // &>
  }
  reply.out() << _tntChunks[5]; // \n\t\t<div class="inhalt">\n
#line 40 "timerconflicts.ecpp"
			if (timerConflicts.size() == 0) {

  reply.out() << _tntChunks[6]; // \t\t\t\t
#line 41 "timerconflicts.ecpp"
  reply.sout() << ( tr("No timer conflicts") );
  reply.out() << _tntChunks[7]; // \n
#line 42 "timerconflicts.ecpp"
			} else {

  reply.out() << _tntChunks[8]; // \t\t\t<table class="listing" cellspacing="0" cellpadding="0">\n
#line 44 "timerconflicts.ecpp"

				for (TimerConflicts::iterator conflict = timerConflicts.begin(); conflict != timerConflicts.end(); ++conflict) {
					const std::list< TimerInConflict >& conflTimers = conflict->ConflictingTimers();
					for (std::list< TimerInConflict >::const_iterator confltimer = conflTimers.begin(); confltimer != conflTimers.end(); ++confltimer) {

  reply.out() << _tntChunks[9]; // \t\t\t\t\t\t<tr class="head">\n\t\t\t\t\t\t\t<td colspan="11">\n\t\t\t\t\t\t\t\t <div class="boxheader"><div><div>
#line 51 "timerconflicts.ecpp"
  reply.sout() << ( FormatDateTime(tr("%A, %x"), conflict->ConflictTime()) + " " + FormatDateTime(tr("%I:%M %p"), conflict->ConflictTime()) + " - " + lexical_cast<std::string, int>(confltimer->percentage) + "%" );
  reply.out() << _tntChunks[10]; // <span style="float:right;"><diff>
#line 51 "timerconflicts.ecpp"
  reply.sout() << ( tr("Server"));
  reply.out() << _tntChunks[11]; // : 
#line 51 "timerconflicts.ecpp"
  reply.sout() << ( (confltimer->remote == "" ) ? tr("local") : confltimer->remote );
  reply.out() << _tntChunks[12]; //  </diff></span></div></div></div>\n\t\t\t\t\t\t\t</td>\n\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t<tr class="description">\n\t\t\t\t\t\t\t<td class="leftcol"><img src="img/transparent.png" alt="" width="16px" height="16px" /></td>\n\t\t\t\t\t\t\t<td><div class="withmargin">
#line 56 "timerconflicts.ecpp"
  reply.sout() << ( trVDR("Channel") );
  reply.out() << _tntChunks[13]; // </div></td>\n\t\t\t\t\t\t\t<td><div class="withmargin">
#line 57 "timerconflicts.ecpp"
  reply.sout() << ( trVDR("Start") );
  reply.out() << _tntChunks[14]; // </div></td>\n\t\t\t\t\t\t\t<td><div class="withmargin">
#line 58 "timerconflicts.ecpp"
  reply.sout() << ( trVDR("Stop") );
  reply.out() << _tntChunks[15]; // </div></td>\n\t\t\t\t\t\t\t<td><div class="withmargin">
#line 59 "timerconflicts.ecpp"
  reply.sout() << ( trVDR("Priority") );
  reply.out() << _tntChunks[16]; // </div></td>\n\t\t\t\t\t\t\t<td><div class="withmargin">
#line 60 "timerconflicts.ecpp"
  reply.sout() << ( trVDR("File") );
  reply.out() << _tntChunks[17]; // </div></td>\n\t\t\t\t\t\t\t<td><div class="withmargin">
#line 61 "timerconflicts.ecpp"
  reply.sout() << ( tr("Searchtimer") );
  reply.out() << _tntChunks[18]; // </div></td>\n\t\t\t\t\t\t\t<td class="action"><img src="img/transparent.png" alt="" width="16px" height="16px" /></td>\n\t\t\t\t\t\t\t<td class="action"><img src="img/transparent.png" alt="" width="16px" height="16px" /></td>\n\t\t\t\t\t\t\t<td class="action"><img src="img/transparent.png" alt="" width="16px" height="16px" /></td>\n\t\t\t\t\t\t\t<td class="action rightcol"><img src="img/transparent.png" alt="" width="16px" height="16px" /></td>\n\t\t\t\t\t\t</tr>\n
#line 67 "timerconflicts.ecpp"

						for (std::list<int>::const_iterator timerIndex = confltimer->concurrentTimerIndices.begin(); timerIndex != confltimer->concurrentTimerIndices.end(); ++timerIndex) {
#if VDRVERSNUM >= 20301
							LOCK_TIMERS_READ;
							cTimer* timer = (cTimer *)Timers->GetById(*timerIndex, (confltimer->remote == "") ? NULL : confltimer->remote.c_str());
#else
							cTimer* timer = Timers.Get(*timerIndex-1);
#endif
							if (!timer) continue;

							std::list< int >::const_iterator nexttimerIndex = timerIndex;
							++nexttimerIndex;
							bool bottom = (nexttimerIndex == confltimer->concurrentTimerIndices.end());

							std::string timerStateImg = "transparent.png";
							std::string timerStateHint;
							if (timer->Id() == confltimer->timerIndex) {
								timerStateImg = "timerconflict.gif";
								timerStateHint = tr("Timer has a conflict.");
							}
							else if (timer->Flags() & tfActive) {
								timerStateImg = "arrow.png";
								timerStateHint = tr("Timer is active.");
							}

							EpgInfoPtr epgEvent;
							std::string longDescription;
							std::string searchTimName;
							std::string searchTimId;
							std::string title;
#if VDRVERSNUM >= 20301
							if (!timer->Event()) {
								LOCK_SCHEDULES_READ;
								timer->SetEventFromSchedule(Schedules);
							}
#else
							if (!timer->Event()) timer->SetEventFromSchedule();
#endif
							if (timer->Event()) {
								epgEvent = EpgEvents::CreateEpgInfo(timer->Channel(), timer->Event());
								longDescription = StringEscapeAndBreak(SortedTimers::GetTimerInfo(*timer)) + "<hr>"
													+ StringEscapeAndBreak(StringWordTruncate(epgEvent->LongDescr(), LiveSetup().GetMaxTooltipChars()))
													+ "<br/><br/>" + tr("Click to view details.");
								searchTimName = SortedTimers::SearchTimerInfo(*timer, "searchtimer");
								searchTimId = SortedTimers::SearchTimerInfo(*timer, "s-id");
								if (searchTimName.empty() && searchTimId.empty() ) searchTimName = SortedTimers::TvScraperTimerInfo(*timer);
								title = epgEvent->Title();
							}

  reply.out() << _tntChunks[19]; // \t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td class="leftcol 
#line 117 "timerconflicts.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << _tntChunks[20]; // "><img src="
#line 117 "timerconflicts.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", timerStateImg) );
  reply.out() << _tntChunks[21]; // " alt="" 
#line 117 "timerconflicts.ecpp"
 if (!timerStateHint.empty()) { 
  // <& tooltip.hint ...
  { 
#line 117 "timerconflicts.ecpp"
    tnt::QueryParams _tnt_cq5;
#line 117 "timerconflicts.ecpp"
    _tnt_cq5.add( "text", (timerStateHint));
#line 117 "timerconflicts.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq5);
    // &>
  }
#line 117 "timerconflicts.ecpp"
 } 
  reply.out() << _tntChunks[22]; // ></img></td>\n\t\t\t\t\t\t\t\t<td class="
#line 118 "timerconflicts.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << _tntChunks[23]; // "><div class="withmargin"><a href="schedule.html\?channel=
#line 118 "timerconflicts.ecpp"
  reply.sout() << ( timer->Channel()->Number());
  reply.out() << _tntChunks[24]; // ">
#line 118 "timerconflicts.ecpp"
  reply.sout() << ( timer->Channel()->Name() );
  reply.out() << _tntChunks[25]; // </a></div></td>\n\t\t\t\t\t\t\t\t<td class="
#line 119 "timerconflicts.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << _tntChunks[26]; // "><div class="withmargin nowrap">
#line 119 "timerconflicts.ecpp"
  reply.sout() << ( FormatDateTime(tr("%I:%M %p"), timer->StartTime()) );
  reply.out() << _tntChunks[27]; // </div></td>\n\t\t\t\t\t\t\t\t<td class="
#line 120 "timerconflicts.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << _tntChunks[28]; // "><div class="withmargin nowrap">
#line 120 "timerconflicts.ecpp"
  reply.sout() << ( FormatDateTime(tr("%I:%M %p"), timer->StopTime()) );
  reply.out() << _tntChunks[29]; // </div></td>\n\t\t\t\t\t\t\t\t<td class="
#line 121 "timerconflicts.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << _tntChunks[30]; // "><div class="withmargin">
#line 121 "timerconflicts.ecpp"
  reply.sout() << ( timer->Priority() );
  reply.out() << _tntChunks[31]; // </div></td>\n\t\t\t\t\t\t\t\t<td class="
#line 122 "timerconflicts.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << _tntChunks[32]; // "><div class="withmargin"><a\n
#line 123 "timerconflicts.ecpp"
								if (!longDescription.empty()) {

  reply.out() << _tntChunks[33]; // \t\t\t\t\t\t\t\t\t
  // <& tooltip.hint ...
  { 
#line 124 "timerconflicts.ecpp"
    tnt::QueryParams _tnt_cq6;
#line 124 "timerconflicts.ecpp"
    _tnt_cq6.add( "text", (longDescription));
#line 124 "timerconflicts.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq6);
    // &>
  }
  // <& tooltip.display ...
  { 
#line 124 "timerconflicts.ecpp"
    tnt::QueryParams _tnt_cq7;
#line 124 "timerconflicts.ecpp"
    _tnt_cq7.add( "domId", (epgEvent->Id()));
#line 124 "timerconflicts.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "display"), request, reply, _tnt_cq7);
    // &>
  }
  reply.out() << _tntChunks[34]; // \n
#line 125 "timerconflicts.ecpp"
								}

  reply.out() << _tntChunks[35]; // \t\t\t\t\t\t\t\t>
#line 126 "timerconflicts.ecpp"
  reply.sout() << ( timer->File() );
  reply.out() << _tntChunks[36]; // </a></div></td>\n\n\t\t\t\t\t\t\t\t<td class="
#line 128 "timerconflicts.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << _tntChunks[37]; // "><div class="withmargin">\n
#line 129 "timerconflicts.ecpp"
								if ( !timer->Local() || searchTimId.empty() ) {

  reply.out() << _tntChunks[38]; // \t\t\t\t\t\t\t\t  
#line 130 "timerconflicts.ecpp"
  reply.sout() << ( searchTimName );
  reply.out() << _tntChunks[39]; // </div></td>\n
#line 131 "timerconflicts.ecpp"
								} else {

  reply.out() << _tntChunks[40]; // \t\t\t\t\t\t\t\t  <a href="edit_searchtimer.html\?searchtimerid=
#line 132 "timerconflicts.ecpp"
  reply.sout() << ( searchTimId );
  reply.out() << _tntChunks[41]; // ">
#line 132 "timerconflicts.ecpp"
  reply.sout() << ( searchTimName );
  reply.out() << _tntChunks[42]; // </a></div></td>\n
#line 133 "timerconflicts.ecpp"
								}

  reply.out() << _tntChunks[43]; // \t\t\t\t\t\t\t\t<td class="action 
#line 134 "timerconflicts.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << _tntChunks[44]; // "><a href="searchresults.html\?searchplain=
#line 134 "timerconflicts.ecpp"
  reply.sout() << ( StringEscapeAndBreak(title) );
  reply.out() << _tntChunks[45]; // "><img src="
#line 134 "timerconflicts.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "search.png") );
  reply.out() << _tntChunks[46]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 134 "timerconflicts.ecpp"
    tnt::QueryParams _tnt_cq8;
#line 134 "timerconflicts.ecpp"
    _tnt_cq8.add( "text", (tr("Search for repeats.")));
#line 134 "timerconflicts.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq8);
    // &>
  }
  reply.out() << _tntChunks[47]; // ></img></a></td>\n\t\t\t\t\t\t\t\t<td class="action 
#line 135 "timerconflicts.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << _tntChunks[48]; // "><a href="timers.html\?timerid=
#line 135 "timerconflicts.ecpp"
  reply.sout() << ( SortedTimers::EncodeDomId(timers.GetTimerId(*timer)) );
  reply.out() << _tntChunks[49]; // &action=toggle"><img src="
#line 135 "timerconflicts.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", (timer->Flags() & tfActive) ? "active.png" : "inactive.png") );
  reply.out() << _tntChunks[50]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 135 "timerconflicts.ecpp"
    tnt::QueryParams _tnt_cq9;
#line 135 "timerconflicts.ecpp"
    _tnt_cq9.add( "text", (tr("Toggle timer active/inactive")));
#line 135 "timerconflicts.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq9);
    // &>
  }
  reply.out() << _tntChunks[51]; // ></img></a></td>\n\t\t\t\t\t\t\t\t<td class="action 
#line 136 "timerconflicts.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << _tntChunks[52]; // ">
  // <& pageelems.edit_timer ...
  { 
#line 136 "timerconflicts.ecpp"
    tnt::QueryParams _tnt_cq10;
#line 136 "timerconflicts.ecpp"
    _tnt_cq10.add( "timerId", (timers.GetTimerId(*timer)));
#line 136 "timerconflicts.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "edit_timer"), request, reply, _tnt_cq10);
    // &>
  }
  reply.out() << _tntChunks[53]; // </td>\n\t\t\t\t\t\t\t\t<td class="action rightcol 
#line 137 "timerconflicts.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << _tntChunks[54]; // "><a href="timers.html\?timerid=
#line 137 "timerconflicts.ecpp"
  reply.sout() << ( SortedTimers::EncodeDomId(timers.GetTimerId(*timer)) );
  reply.out() << _tntChunks[55]; // &action=delete"><img src="
#line 137 "timerconflicts.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "del.png") );
  reply.out() << _tntChunks[56]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 137 "timerconflicts.ecpp"
    tnt::QueryParams _tnt_cq11;
#line 137 "timerconflicts.ecpp"
    _tnt_cq11.add( "text", (tr("Delete timer")));
#line 137 "timerconflicts.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq11);
    // &>
  }
  reply.out() << _tntChunks[57]; // ></img></a></td>\n\t\t\t\t\t\t\t</tr>\n
#line 139 "timerconflicts.ecpp"
						}

  reply.out() << _tntChunks[58]; // </%cpp\n\t\t\t\t\t\t<tr class="spacer">\n\t\t\t\t\t\t\t<td colspan="10"/>\n\t\t\t\t\t\t</tr>\n
#line 144 "timerconflicts.ecpp"

					}
				}

  reply.out() << _tntChunks[59]; // \t\t\t</table>\n
#line 149 "timerconflicts.ecpp"
			}

  reply.out() << _tntChunks[60]; // \t\t</div>\n\t</body>\n</html>\n
  // <%include> page_exit.eh
  reply.out() << _tntChunks[61]; // \n
#line 5 "page_exit.eh"

	spoint.commit();
} catch ( vdrlive::HtmlError const& ex ) {
	tnt::QueryParams param = qparam;
	param.add( "pageTitle", pageTitle );
	param.add( "errorMessage", ex.what() );
	callComp( "error", request, reply, param );
}

  // </%include>
  reply.out() << _tntChunks[62]; // \n\n
  // <%/cpp>
  return DEFAULT;
}

} // namespace
