////////////////////////////////////////////////////////////////////////
// edit_timer.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.edit_timer")

// <%pre>
#line 1 "edit_timer.ecpp"


#include <tools.h>
#include <timers.h>
#include <setup.h>
#include <epg_events.h>
#include <timerconflict.h>
#include <livefeatures.h>
#include <epgsearch.h>
#include <users.h>

#include <vdr/timers.h>
#include <vdr/svdrp.h>

using namespace vdrlive;


#line 1 "page_init.eh"

// do not add to Makefile
// and do not write a ecpp comment into this file. It must produce no
// html output not even an empty line.
#include <tnt/savepoint.h>
#include <exception.h>

#line 2 "page_exit.eh"

#include <exception.h>

// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
};

static tnt::EcppComponentFactoryImpl<_component_> Factory("edit_timer");

static const char* rawData = " \001\000\000\213\001\000\000\224\001\000\000\226\001\000\000\231\001\000\000\232\001\000"
  "\000\335\001\000\000\337\001\000\000\342\001\000\000\343\001\000\000'\002\000\000r\002\000\000\241\002\000\000`\003"
  "\000\000\306\003\000\000@\004\000\000u\004\000\000\335\004\000\000\022\005\000\000\203\005\000\000\220\005\000\000"
  "\303\005\000\000\035\006\000\000l\006\000\000\233\006\000\000\335\006\000\000n\007\000\000}\007\000\000\231\007\000"
  "\000\241\007\000\000\253\007\000\000\323\007\000\000\025\010\000\000\234\010\000\000\262\010\000\000\264\010\000\000"
  "\317\010\000\000\327\010\000\000\341\010\000\000\013\t\000\000N\t\000\000\246\t\000\000\376\t\000\000\212\n\000\000"
  "\254\n\000\000&\013\000\000H\013\000\000\302\013\000\000\344\013\000\000^\014\000\000\200\014\000\000\373\014\000\000"
  "\035\015\000\000\227\015\000\000\271\015\000\0003\016\000\000U\016\000\000\306\016\000\000\027\017\000\000p\017\000"
  "\000\300\017\000\000\031\020\000\000m\020\000\000\303\020\000\0001\021\000\000\211\021\000\000\367\021\000\000\250"
  "\022\000\000\364\022\000\000l\023\000\000\221\023\000\000\222\023\000\000\n<html>\n\t<head>\n<meta name=\"viewport\" "
  "content=\"width=device-width, initial-scale=1\" />\n\t\t<title>VDR Live - </title>\n\t\t\n\t\t\n\t</head>\n\t<body on"
  "load=\"adjustHeader()\" onresize=\"adjustHeader()\">\n\t\t\n\t\t\n\t\t<div class=\"inhalt\">\n\t\t\t<form method=\"po"
  "st\" name=\"edit_timer\" id=\"\" action=\"edit_timer.ecpp\">\n\t\t\t\t<input type=\"hidden\" name=\"timerid\" value="
  "\"\"/>\n\t\t\t\t<input type=\"hidden\" name=\"aux\" value=\"\"/>\n\t\t\t\t<table class=\"formular\" cellpadding=\"0\""
  " cellspacing=\"0\">\n\t\t\t\t\t<tr class=\"head\">\n\t\t\t\t\t\t<td class=\"toprow leftcol rightcol\" colspan=\"2\"><"
  "div class=\"boxheader\"><div><div class=\"caption\"></div></div></div></td>\n\t\t\t\t\t</tr>\n\n\t\t\t\t\t<tr>\n\t\t"
  "\t\t\t\t<td class=\"label leftcol\"><div class=\"withmargin\">:</div></td>\n\t\t\t\t\t\t<td class=\"rightcol\">\n\t\t"
  "\t\t\t\t\t<div class=\"dotted\">\n\t\t\t\t\t\t\t\t<input id=\"active_1\" name=\"active\" value=\"1\"  type=\"radio\">"
  "</input>\n\t\t\t\t\t\t\t\t<label for=\"active_1\"></label>\n\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t\t<div class=\"dotted\""
  ">\n\t\t\t\t\t\t\t\t<input id=\"active_0\" name=\"active\" value=\"0\"  type=\"radio\"></input>\n\t\t\t\t\t\t\t\t<labe"
  "l for=\"active_0\"></label>\n\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t"
  "<td class=\"label leftcol\"><div class=\"withmargin\">:</div></td>\n\t\t\t\t\t\t<td class=\"rightcol\"><div class=\"w"
  "ithmargin\"></div></td>\n\t\t\t\t\t</tr>\n\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class=\"label leftcol\"><div class=\"with"
  "margin\">:</div></td>\n\t\t\t\t\t\t<td class=\"rightcol\"><input type=\"text\" name=\"title\" value=\"\" size=\"55\" "
  "class=\"width99\" /></td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class=\"label leftcol\"><div class=\"with"
  "margin\">:</div></td>\n\t\t\t\t\t\t<td class=\"rightcol\"><select name=\"remoteServerName\" size=\"1\" id=\"remoteSer"
  "verName\" style=\"margin-top: 5px\">\n\t\t\t\t\t\t\t<option/>\n\t\t\t\t\t\t\t<option\n\t\t\t\t\t\t\t\tselected=\"sele"
  "cted\"\n\t\t\t\t\t\t\t></option>\n\t\t\t\t\t\t\t</select>\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t"
  "\t\t\t<td class=\"label leftcol\"><div class=\"withmargin\">:</div></td>\n\t\t\t\t\t\t<td class=\"rightcol\"><select "
  "name=\"directory\" size=\"1\" id=\"directory\" style=\"margin-top: 5px\">\n\t\t\t\t\t\t     <option/>\n\t\t\t\t\t\t\t"
  "<option value=\"\"\n\t\t\t\t\t\t\tselected=\"selected\"\n\t\t\t\t\t\t\t></option>\n\t\t\t\t\t\t   </select>\n\t\t\t\t"
  "\t\t</td>\n\t\t\t\t\t</tr>\n\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class=\"label leftcol\"><div class=\"withmargin\">:</di"
  "v></td>\n\t\t\t\t\t\t<td class=\"rightcol\"><input id=\"date\" name=\"date\" type=\"date\" value=\"\" /></td>\n\t\t\t"
  "\t\t</tr>\n\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class=\"label leftcol\"><div class=\"withmargin\">:</div></td>\n\t\t\t\t"
  "\t\t<td class=\"rightcol\">\n\t\t\t\t\t\t\t<div class=\"dotted\">\n\t\t\t\t\t\t\t\t<input id=\"wday_mon\" type=\"chec"
  "kbox\" name=\"wday_mon\" value=\"1\"  />\n\t\t\t\t\t\t\t\t<label for=\"wday_mon\"></label>\n\t\t\t\t\t\t\t</div>\n\t"
  "\t\t\t\t\t\t<div class=\"dotted\">\n\t\t\t\t\t\t\t\t<input id=\"wday_tue\" type=\"checkbox\" name=\"wday_tue\" value="
  "\"1\"  />\n\t\t\t\t\t\t\t\t<label for=\"wday_tue\"></label>\n\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t\t<div class=\"dotted"
  "\">\n\t\t\t\t\t\t\t\t<input id=\"wday_wed\" type=\"checkbox\" name=\"wday_wed\" value=\"1\"  />\n\t\t\t\t\t\t\t\t<lab"
  "el for=\"wday_wed\"></label>\n\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t\t<div class=\"dotted\">\n\t\t\t\t\t\t\t\t<input id="
  "\"wday_thu\" type=\"checkbox\" name=\"wday_thu\" value=\"1\"  />\n\t\t\t\t\t\t\t\t<label for=\"wday_thu\"></label>\n"
  "\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t\t<div class=\"dotted\">\n\t\t\t\t\t\t\t\t<input id =\"wday_fri\" type=\"checkbox\""
  " name=\"wday_fri\" value=\"1\"  />\n\t\t\t\t\t\t\t\t<label for=\"wday_fri\"></label>\n\t\t\t\t\t\t\t</div>\n\t\t\t\t"
  "\t\t\t<div class=\"dotted\">\n\t\t\t\t\t\t\t\t<input id=\"wday_sat\" type=\"checkbox\" name=\"wday_sat\" value=\"1\" "
  " />\n\t\t\t\t\t\t\t\t<label for=\"wday_sat\"></label>\n\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t\t<div class=\"dotted\">\n\t"
  "\t\t\t\t\t\t\t<input id=\"wday_sun\" type=\"checkbox\" name=\"wday_sun\" value=\"1\"  />\n\t\t\t\t\t\t\t\t<label for="
  "\"wday_sun\"></label>\n\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td cl"
  "ass=\"label leftcol\"><div class=\"withmargin\">:</div></td>\n\t\t\t\t\t\t<td class=\"rightcol\"><input type=\"time\""
  " name=\"start_s\" value=\"\" /> </td>\n\t\t\t\t\t</tr>\n\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class=\"label leftcol\"><di"
  "v class=\"withmargin\">:</div></td>\n\t\t\t\t\t\t<td class=\"rightcol\"><input type=\"time\" name=\"stop_s\" value=\""
  "\" />\n</td>\n\t\t\t\t\t</tr>\n\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class=\"label leftcol\"><div class=\"withmargin\">:<"
  "/div></td>\n\t\t\t\t\t\t<td class=\"rightcol\"><input type=\"checkbox\" name=\"vps\" value=\"1\" /></td>\n\t\t\t\t\t<"
  "/tr>\n\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class=\"label leftcol\"><div class=\"withmargin\">:</div></td>\n\t\t\t\t\t\t<"
  "td class=\"rightcol\"><input type=\"number\" size=\"6\" min=\"0\" max=\"99\" name=\"priority\" value=\"\" /></td>\n\t"
  "\t\t\t\t</tr>\n\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class=\"label leftcol\"><div class=\"withmargin\">:</div></td>\n\t\t"
  "\t\t\t\t<td class=\"rightcol\"><input type=\"number\" size=\"6\" min=\"0\" max=\"99\" name=\"lifetime\" value=\"\" />"
  "</td>\n\t\t\t\t\t</tr>\n\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class=\"buttonpanel leftcol rightcol bottomrow\" colspan=\""
  "2\">\n\t\t\t\t\t\t\t<div class=\"withmargin\">\n\t\t\t\t\t\t\t<button class=\"green\" type=\"submit\"></button>\n\t\t"
  "\t\t\t\t\t<button type=\"button\" class=\"red\" onclick=\"history.back()\"></button>\n\t\t\t\t\t\t\t</div>\n\t\t\t\t"
  "\t\t</td>\n\t\t\t\t\t</tr>\n\t\t\t\t</table>\n\t\t\t</form>\n\t\t\t<div style=\"color: red; margin: 0 auto;\">\n\t\t"
  "\t\t\n\t\t\t</div>\n\t\t</div>\n\t</body>\n</html>\n\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl)
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

template <typename T>
inline void _tnt_ignore_unused(const T&) { }

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("edit_timer " << qparam.getUrl());

  tnt::DataChunks _tntChunks(rawData);

  // <%args>
std::string timerid = qparam.get< std::string >("timerid");
std::string epgid = qparam.get< std::string >("epgid");
std::string async = qparam.get< std::string >("async");
tChannelID channel = qparam.get< tChannelID >("channel");
std::string channel_string = qparam.get< std::string >("channel_string", ( ""));
int active = qparam.get< int >("active", ( 1));
std::string title = qparam.get< std::string >("title", ( ""));
std::string remoteServerName = qparam.get< std::string >("remoteServerName", ( ""));
std::string date = qparam.get< std::string >("date", ( ""));
bool wday_mon = qparam.get< bool >("wday_mon", ( false));
bool wday_tue = qparam.get< bool >("wday_tue", ( false));
bool wday_wed = qparam.get< bool >("wday_wed", ( false));
bool wday_thu = qparam.get< bool >("wday_thu", ( false));
bool wday_fri = qparam.get< bool >("wday_fri", ( false));
bool wday_sat = qparam.get< bool >("wday_sat", ( false));
bool wday_sun = qparam.get< bool >("wday_sun", ( false));
std::string start_s = qparam.get< std::string >("start_s", ( "00:00"));
std::string stop_s = qparam.get< std::string >("stop_s", ( "00:00"));
bool vps = qparam.get< bool >("vps", ( 0));
int priority = qparam.get< int >("priority", ( 0));
int lifetime = qparam.get< int >("lifetime", ( 0));
std::string aux = qparam.get< std::string >("aux", ( ""));
std::string directory = qparam.get< std::string >("directory", ( ""));
  // </%args>

#line 46 "edit_timer.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 47 "edit_timer.ecpp"
  typedef std::string edit_timerreferer_type;
  TNT_SESSION_SHARED_VAR(std::string, edit_timerreferer, ());   // <%session> std::string edit_timerreferer
  _tnt_ignore_unused<edit_timerreferer_type>(edit_timerreferer);
#line 48 "edit_timer.ecpp"
  typedef TimerConflictNotifier timerNotifier_type;
  TNT_SESSION_SHARED_VAR(TimerConflictNotifier, timerNotifier, ());   // <%session> TimerConflictNotifier timerNotifier
  _tnt_ignore_unused<timerNotifier_type>(timerNotifier);
#line 51 "edit_timer.ecpp"
  typedef const cTimer* timer_type;
  TNT_REQUEST_PAGE_VAR(const cTimer*, timer, ());   // <%request> const cTimer* timer
  _tnt_ignore_unused<timer_type>(timer);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  // <%include> page_init.eh
#line 11 "page_init.eh"

try {
	reply.setHeader("Expires", "Mon, 26 Jul 1997 05:00:00 GMT");
	tnt::Savepoint spoint( reply );

  // </%include>
#line 54 "edit_timer.ecpp"

#if TNTVERSION >= 30000
	channel = channel.FromString(channel_string.c_str());  // Tntnet30: get struct channel from parameter string
#endif
	if (!logged_in && LiveSetup().UseAuth()) return reply.redirect("login.html");

	if (!cUser::CurrentUserHasRightTo(UR_EDITTIMERS))
		throw HtmlError( tr("Sorry, no permission. Please contact your administrator!") );

	bool ajaxReq = !async.empty() && (lexical_cast<int>(async) != 0);

	tChannelID channelid = tChannelID();
	tEventID eventid = tEventID();

	std::string message;
	cMutexLock timersLock( &LiveTimerManager() );
	SortedTimers& timers = LiveTimerManager().GetTimers();

	timer = 0;
	int timerId = 0;
	if ( !timerid.empty() ) {
		std::string tId = SortedTimers::DecodeDomId(timerid);
//		dsyslog("live: DEBUG: TIMER: timerid = %s", timerid);
//		dsyslog("live: DEBUG: TIMER: tId = %s", tId.c_str());
		timer = timers.GetByTimerId(tId);
		if ( timer == 0 )
			throw HtmlError( tr("Couldn't find timer. Maybe you mistyped your request?") );
                else 
                   	timerId = timer->Id();
	}

	if ( request.getMethod() == "POST" ) {
		const char* oldRemote = NULL;
		if ( timer != 0 ) {
			oldRemote = timer->Remote();
//			dsyslog("live: found valid timer on server '%s'", oldRemote);
                }
		uint flags = ( active ? tfActive : 0 ) | ( vps ? tfVps : 0 );
		std::string weekdays = std::string( wday_mon ? "M" : "-" ) + ( wday_tue ? "T" : "-" ) + ( wday_wed ? "W" : "-" )
							  + ( wday_thu ? "T" : "-" ) + ( wday_fri ? "F" : "-" ) + ( wday_sat ? "S" : "-" )
							  + ( wday_sun ? "S" : "-" );
		int start = timeStringToInt(start_s);
		int stop = timeStringToInt(stop_s);

		if (!directory.empty())
		   title = directory + "~" + title;

		if (title.empty())
			message = tr("Please set a title for the timer!");
		else
		{
			const char* remote = ( remoteServerName == "") ? NULL : remoteServerName.c_str();
//		dsyslog("live: remote '%s'", remote);
			LiveTimerManager().UpdateTimer( timerId, remote, oldRemote, flags, channel, weekdays, date, start, stop, priority, lifetime, title, aux );
			timerNotifier.SetTimerModification();
			return reply.redirect(!edit_timerreferer.empty()?edit_timerreferer:"timers.html");
		}
	}

	if (message.empty())
		edit_timerreferer = request.getHeader("Referer:", "timers.html");

	std::unique_ptr<cTimer> eventTimer;
	if ( timer == 0 && !epgid.empty()) {
		EpgEvents::DecodeDomId(epgid, channelid, eventid);
		if ( channelid.Valid() && eventid != 0 ) {
			cSchedule const* schedule;
#if VDRVERSNUM >= 20301
			{
				LOCK_SCHEDULES_READ;
				schedule = Schedules->GetSchedule( channelid );
			}
#else
			cSchedulesLock schedLock;
			cSchedules const* schedules = cSchedules::Schedules( schedLock );
			schedule = schedules->GetSchedule( channelid );
#endif
			const cEvent *event = schedule->GetEvent( eventid );
			if (event) eventTimer.reset( new cTimer( event ) );
			else {
				esyslog("live: edit timer with eventid %d not valid", eventid);
				eventTimer.reset( new cTimer() );
				eventTimer->SetFlags( tfActive );
                        }
		} else {
			eventTimer.reset( new cTimer() );
			eventTimer->SetFlags( tfActive );
		}
		timer = eventTimer.get();
	}
	if (timer == 0)
	{
		eventTimer.reset( new cTimer() );
		eventTimer->SetFlags( tfActive );
		timer = eventTimer.get();
	}

	if ( timer != 0 ) {
		active = timer->Flags() & tfActive;
		channel = timer->Channel()->GetChannelID();
		title = timer->File() ? timer->File() : "";
		remoteServerName = timer->Remote() ? timer->Remote() : "";
//                dsyslog("live: remoteServerName '%s'", remoteServerName.c_str());
		if ( LiveFeatures<features::epgsearch>().Recent() ) {
			std::vector<std::string> directories = StringSplit( title, '~' );
			if (directories.size() > 1) {
				directory = directories[0];
				title = title.substr(directory.size()+1);
			}
		}
		// TRANSLATORS: only adjust the ordering and separators, don't translate the m's, d's and y's
		date = timer->Day() ? DatePickerToC(timer->Day(), "yyyy-mm-dd") : "";
		wday_mon = timer->WeekDays() & 0x01;
		wday_tue = timer->WeekDays() & 0x02;
		wday_wed = timer->WeekDays() & 0x04;
		wday_thu = timer->WeekDays() & 0x08;
		wday_fri = timer->WeekDays() & 0x10;
		wday_sat = timer->WeekDays() & 0x20;
		wday_sun = timer->WeekDays() & 0x40;
                start_s = intToTimeString(timer->Start() );
                stop_s = intToTimeString(timer->Stop() );
		vps = timer->Flags() & tfVps;
		priority = timer->Priority();
		lifetime = timer->Lifetime();
		aux = timer->Aux() ? timer->Aux() : "";
	}

  // <& pageelems.doc_type ...
  { 
#line 181 "edit_timer.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 181 "edit_timer.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "doc_type"), request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << _tntChunks[0]; // \n<html>\n\t<head>\n<meta name="viewport" content="width=device-width, initial-scale=1" />\n\t\t<title>VDR Live - 
#line 185 "edit_timer.ecpp"
  reply.sout() << ( timer ? tr("Edit timer") : tr("New timer") );
  reply.out() << _tntChunks[1]; // </title>\n
#line 186 "edit_timer.ecpp"

	if (!ajaxReq) {

  reply.out() << _tntChunks[2]; // \t\t
  // <& pageelems.stylesheets ...
  { 
#line 189 "edit_timer.ecpp"
    tnt::QueryParams _tnt_cq1;
#line 189 "edit_timer.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "stylesheets"), request, reply, _tnt_cq1);
    // &>
  }
  reply.out() << _tntChunks[3]; // \n\t\t
  // <& pageelems.ajax_js ...
  { 
#line 190 "edit_timer.ecpp"
    tnt::QueryParams _tnt_cq2;
#line 190 "edit_timer.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_js"), request, reply, _tnt_cq2);
    // &>
  }
  reply.out() << _tntChunks[4]; // \n
#line 191 "edit_timer.ecpp"

	}

  reply.out() << _tntChunks[5]; // \t</head>\n\t<body onload="adjustHeader()" onresize="adjustHeader()">\n
#line 196 "edit_timer.ecpp"

	if (!ajaxReq) {

  reply.out() << _tntChunks[6]; // \t\t
  // <& pageelems.logo ...
  { 
#line 199 "edit_timer.ecpp"
    tnt::QueryParams _tnt_cq3;
#line 199 "edit_timer.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "logo"), request, reply, _tnt_cq3);
    // &>
  }
  reply.out() << _tntChunks[7]; // \n\t\t
  // <& menu ...
  { 
#line 200 "edit_timer.ecpp"
    tnt::QueryParams _tnt_cq4;
#line 200 "edit_timer.ecpp"
    _tnt_cq4.add( "active", ("timers"));
#line 200 "edit_timer.ecpp"
    callComp(tnt::Compident(std::string(), "menu"), request, reply, _tnt_cq4);
    // &>
  }
  reply.out() << _tntChunks[8]; // \n
#line 201 "edit_timer.ecpp"

	}

  reply.out() << _tntChunks[9]; // \t\t<div class="inhalt">\n\t\t\t<form method="post" name="edit_timer" id="
#line 205 "edit_timer.ecpp"
  reply.sout() << ( timerid );
  reply.out() << _tntChunks[10]; // " action="edit_timer.ecpp">\n\t\t\t\t<input type="hidden" name="timerid" value="
#line 206 "edit_timer.ecpp"
  reply.sout() << ( timerid );
  reply.out() << _tntChunks[11]; // "/>\n\t\t\t\t<input type="hidden" name="aux" value="
#line 207 "edit_timer.ecpp"
  reply.sout() << ( aux );
  reply.out() << _tntChunks[12]; // "/>\n\t\t\t\t<table class="formular" cellpadding="0" cellspacing="0">\n\t\t\t\t\t<tr class="head">\n\t\t\t\t\t\t<td class="toprow leftcol rightcol" colspan="2"><div class="boxheader"><div><div class="caption">
#line 210 "edit_timer.ecpp"
  reply.sout() << ( timer ? tr("Edit timer") : tr("New timer") );
  reply.out() << _tntChunks[13]; // </div></div></div></td>\n\t\t\t\t\t</tr>\n\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 214 "edit_timer.ecpp"
  reply.sout() << ( trVDR("Active") );
  reply.out() << _tntChunks[14]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol">\n\t\t\t\t\t\t\t<div class="dotted">\n\t\t\t\t\t\t\t\t<input id="active_1" name="active" value="1" 
#line 217 "edit_timer.ecpp"
 reply.out() << ( active ? "checked=\"checked\"" : "" ); 
  reply.out() << _tntChunks[15]; //  type="radio"></input>\n\t\t\t\t\t\t\t\t<label for="active_1">
#line 218 "edit_timer.ecpp"
  reply.sout() << ( trVDR("yes") );
  reply.out() << _tntChunks[16]; // </label>\n\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t\t<div class="dotted">\n\t\t\t\t\t\t\t\t<input id="active_0" name="active" value="0" 
#line 221 "edit_timer.ecpp"
 reply.out() << ( !active ? "checked=\"checked\"" : "" ); 
  reply.out() << _tntChunks[17]; //  type="radio"></input>\n\t\t\t\t\t\t\t\t<label for="active_0">
#line 222 "edit_timer.ecpp"
  reply.sout() << ( trVDR("no") );
  reply.out() << _tntChunks[18]; // </label>\n\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 228 "edit_timer.ecpp"
  reply.sout() << ( trVDR("Channel") );
  reply.out() << _tntChunks[19]; // :</div></td>\n
#line 229 "edit_timer.ecpp"

#if TNTVERSION >= 30000
						std::string name = "channel_string";  // Tntnet30 does not work with parameter type tChannelID
#else
						std::string name = "channel";
#endif

  reply.out() << _tntChunks[20]; // \t\t\t\t\t\t<td class="rightcol"><div class="withmargin">
  // <& channels_widget ...
  { 
#line 236 "edit_timer.ecpp"
    tnt::QueryParams _tnt_cq5;
#line 236 "edit_timer.ecpp"
    _tnt_cq5.add( "channelid", (true));
#line 236 "edit_timer.ecpp"
    _tnt_cq5.add( "name", (name));
#line 236 "edit_timer.ecpp"
    _tnt_cq5.add( "selected", (channel));
#line 236 "edit_timer.ecpp"
    callComp(tnt::Compident(std::string(), "channels_widget"), request, reply, _tnt_cq5);
    // &>
  }
  reply.out() << _tntChunks[21]; // </div></td>\n\t\t\t\t\t</tr>\n\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 240 "edit_timer.ecpp"
  reply.sout() << ( tr("Title" ) );
  reply.out() << _tntChunks[22]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol"><input type="text" name="title" value="
#line 241 "edit_timer.ecpp"
  reply.sout() << ( title );
  reply.out() << _tntChunks[23]; // " size="55" class="width99" /></td>\n\t\t\t\t\t</tr>\n
#line 243 "edit_timer.ecpp"

					cStringList svdrpServerNames;
					if (GetSVDRPServerNames(&svdrpServerNames)) {
						svdrpServerNames.Sort(true);

  reply.out() << _tntChunks[24]; // \t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 249 "edit_timer.ecpp"
  reply.sout() << ( tr("Server" ) );
  reply.out() << _tntChunks[25]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol"><select name="remoteServerName" size="1" id="remoteServerName" style="margin-top: 5px">\n\t\t\t\t\t\t\t<option/>\n
#line 252 "edit_timer.ecpp"

							for (int i = 0; i < svdrpServerNames.Size(); i++) {
							std::string rsrv = svdrpServerNames[i];

  reply.out() << _tntChunks[26]; // \t\t\t\t\t\t\t<option\n
#line 257 "edit_timer.ecpp"
								if (rsrv == remoteServerName) {

  reply.out() << _tntChunks[27]; // \t\t\t\t\t\t\t\tselected="selected"\n
#line 259 "edit_timer.ecpp"
								}

  reply.out() << _tntChunks[28]; // \t\t\t\t\t\t\t>
#line 260 "edit_timer.ecpp"
  reply.sout() << ( rsrv );
  reply.out() << _tntChunks[29]; // </option>\n
#line 261 "edit_timer.ecpp"

							}

  reply.out() << _tntChunks[30]; // \t\t\t\t\t\t\t</select>\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n
#line 267 "edit_timer.ecpp"

					svdrpServerNames.Clear();
					}

#line 271 "edit_timer.ecpp"

					if ( LiveFeatures<features::epgsearch>().Recent() ) {
						RecordingDirs recordingdirs(true);

  reply.out() << _tntChunks[31]; // \t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 276 "edit_timer.ecpp"
  reply.sout() << ( tr("Directory" ) );
  reply.out() << _tntChunks[32]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol"><select name="directory" size="1" id="directory" style="margin-top: 5px">\n\t\t\t\t\t\t     <option/>\n
#line 279 "edit_timer.ecpp"

						for (RecordingDirs::iterator rdir = recordingdirs.begin(); rdir != recordingdirs.end(); ++rdir) {
							std::string dir = *rdir;

  reply.out() << _tntChunks[33]; // \t\t\t\t\t\t\t<option value="
#line 283 "edit_timer.ecpp"
  reply.sout() << ( dir );
  reply.out() << _tntChunks[34]; // "\n
#line 284 "edit_timer.ecpp"
							if (*rdir == directory) {

  reply.out() << _tntChunks[35]; // \t\t\t\t\t\t\tselected="selected"\n
#line 286 "edit_timer.ecpp"
							}

  reply.out() << _tntChunks[36]; // \t\t\t\t\t\t\t>
#line 287 "edit_timer.ecpp"
  reply.sout() << ( dir );
  reply.out() << _tntChunks[37]; // </option>\n
#line 288 "edit_timer.ecpp"
						}

  reply.out() << _tntChunks[38]; // \t\t\t\t\t\t   </select>\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n
#line 292 "edit_timer.ecpp"

					}

  reply.out() << _tntChunks[39]; // \n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 297 "edit_timer.ecpp"
  reply.sout() << ( trVDR("Day") );
  reply.out() << _tntChunks[40]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol"><input id="date" name="date" type="date" value="
#line 298 "edit_timer.ecpp"
  reply.sout() << ( date );
  reply.out() << _tntChunks[41]; // " /></td>\n\t\t\t\t\t</tr>\n\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 302 "edit_timer.ecpp"
  reply.sout() << ( tr("Weekday") );
  reply.out() << _tntChunks[42]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol">\n\t\t\t\t\t\t\t<div class="dotted">\n\t\t\t\t\t\t\t\t<input id="wday_mon" type="checkbox" name="wday_mon" value="1" 
#line 305 "edit_timer.ecpp"
 reply.out() << ( wday_mon ? "checked=\"checked\"" : "" ); 
  reply.out() << _tntChunks[43]; //  />\n\t\t\t\t\t\t\t\t<label for="wday_mon">
#line 306 "edit_timer.ecpp"
  reply.sout() << ( tr("Monday") );
  reply.out() << _tntChunks[44]; // </label>\n\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t\t<div class="dotted">\n\t\t\t\t\t\t\t\t<input id="wday_tue" type="checkbox" name="wday_tue" value="1" 
#line 309 "edit_timer.ecpp"
 reply.out() << ( wday_tue ? "checked=\"checked\"" : "" ); 
  reply.out() << _tntChunks[45]; //  />\n\t\t\t\t\t\t\t\t<label for="wday_tue">
#line 310 "edit_timer.ecpp"
  reply.sout() << ( tr("Tuesday") );
  reply.out() << _tntChunks[46]; // </label>\n\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t\t<div class="dotted">\n\t\t\t\t\t\t\t\t<input id="wday_wed" type="checkbox" name="wday_wed" value="1" 
#line 313 "edit_timer.ecpp"
 reply.out() << ( wday_wed ? "checked=\"checked\"" : "" ); 
  reply.out() << _tntChunks[47]; //  />\n\t\t\t\t\t\t\t\t<label for="wday_wed">
#line 314 "edit_timer.ecpp"
  reply.sout() << ( tr("Wednesday") );
  reply.out() << _tntChunks[48]; // </label>\n\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t\t<div class="dotted">\n\t\t\t\t\t\t\t\t<input id="wday_thu" type="checkbox" name="wday_thu" value="1" 
#line 317 "edit_timer.ecpp"
 reply.out() << ( wday_thu ? "checked=\"checked\"" : "" ); 
  reply.out() << _tntChunks[49]; //  />\n\t\t\t\t\t\t\t\t<label for="wday_thu">
#line 318 "edit_timer.ecpp"
  reply.sout() << ( tr("Thursday") );
  reply.out() << _tntChunks[50]; // </label>\n\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t\t<div class="dotted">\n\t\t\t\t\t\t\t\t<input id ="wday_fri" type="checkbox" name="wday_fri" value="1" 
#line 321 "edit_timer.ecpp"
 reply.out() << ( wday_fri ? "checked=\"checked\"" : "" ); 
  reply.out() << _tntChunks[51]; //  />\n\t\t\t\t\t\t\t\t<label for="wday_fri">
#line 322 "edit_timer.ecpp"
  reply.sout() << ( tr("Friday") );
  reply.out() << _tntChunks[52]; // </label>\n\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t\t<div class="dotted">\n\t\t\t\t\t\t\t\t<input id="wday_sat" type="checkbox" name="wday_sat" value="1" 
#line 325 "edit_timer.ecpp"
 reply.out() << ( wday_sat ? "checked=\"checked\"" : "" ); 
  reply.out() << _tntChunks[53]; //  />\n\t\t\t\t\t\t\t\t<label for="wday_sat">
#line 326 "edit_timer.ecpp"
  reply.sout() << ( tr("Saturday") );
  reply.out() << _tntChunks[54]; // </label>\n\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t\t<div class="dotted">\n\t\t\t\t\t\t\t\t<input id="wday_sun" type="checkbox" name="wday_sun" value="1" 
#line 329 "edit_timer.ecpp"
 reply.out() << ( wday_sun ? "checked=\"checked\"" : "" ); 
  reply.out() << _tntChunks[55]; //  />\n\t\t\t\t\t\t\t\t<label for="wday_sun">
#line 330 "edit_timer.ecpp"
  reply.sout() << ( tr("Sunday") );
  reply.out() << _tntChunks[56]; // </label>\n\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 336 "edit_timer.ecpp"
  reply.sout() << ( trVDR("Start") );
  reply.out() << _tntChunks[57]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol"><input type="time" name="start_s" value="
#line 337 "edit_timer.ecpp"
  reply.sout() << ( start_s );
  reply.out() << _tntChunks[58]; // " /> </td>\n\t\t\t\t\t</tr>\n\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 341 "edit_timer.ecpp"
  reply.sout() << ( trVDR("Stop") );
  reply.out() << _tntChunks[59]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol"><input type="time" name="stop_s" value="
#line 342 "edit_timer.ecpp"
  reply.sout() << ( stop_s );
  reply.out() << _tntChunks[60]; // " />\n</td>\n\t\t\t\t\t</tr>\n\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 347 "edit_timer.ecpp"
  reply.sout() << ( tr("Use VPS") );
  reply.out() << _tntChunks[61]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol"><input type="checkbox" name="vps" value="1" 
#line 348 "edit_timer.ecpp"
 reply.out() << ( vps ? "checked=\"checked\"" : "" ); 
  reply.out() << _tntChunks[62]; // /></td>\n\t\t\t\t\t</tr>\n\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 352 "edit_timer.ecpp"
  reply.sout() << ( trVDR("Priority") );
  reply.out() << _tntChunks[63]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol"><input type="number" size="6" min="0" max="99" name="priority" value="
#line 353 "edit_timer.ecpp"
  reply.sout() << ( priority );
  reply.out() << _tntChunks[64]; // " /></td>\n\t\t\t\t\t</tr>\n\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 357 "edit_timer.ecpp"
  reply.sout() << ( trVDR("Lifetime") );
  reply.out() << _tntChunks[65]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol"><input type="number" size="6" min="0" max="99" name="lifetime" value="
#line 358 "edit_timer.ecpp"
  reply.sout() << ( lifetime );
  reply.out() << _tntChunks[66]; // " /></td>\n\t\t\t\t\t</tr>\n\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="buttonpanel leftcol rightcol bottomrow" colspan="2">\n\t\t\t\t\t\t\t<div class="withmargin">\n\t\t\t\t\t\t\t<button class="green" type="submit">
#line 364 "edit_timer.ecpp"
  reply.sout() << ( tr("Save") );
  reply.out() << _tntChunks[67]; // </button>\n\t\t\t\t\t\t\t<button type="button" class="red" onclick="history.back()">
#line 365 "edit_timer.ecpp"
  reply.sout() << ( tr("Cancel") );
  reply.out() << _tntChunks[68]; // </button>\n\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\t\t\t\t</table>\n\t\t\t</form>\n\t\t\t<div style="color: red; margin: 0 auto;">\n\t\t\t\t
#line 372 "edit_timer.ecpp"
  reply.sout() << ( message );
  reply.out() << _tntChunks[69]; // \n\t\t\t</div>\n\t\t</div>\n\t</body>\n</html>\n
  // <%include> page_exit.eh
  reply.out() << _tntChunks[70]; // \n
#line 5 "page_exit.eh"

	spoint.commit();
} catch ( vdrlive::HtmlError const& ex ) {
	tnt::QueryParams param = qparam;
	param.add( "pageTitle", pageTitle );
	param.add( "errorMessage", ex.what() );
	callComp( "error", request, reply, param );
}

  // </%include>
  // <%/cpp>
  return DEFAULT;
}

} // namespace
