////////////////////////////////////////////////////////////////////////
// searchtimers.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.searchtimers")

// <%pre>
#line 1 "searchtimers.ecpp"


#include <epgsearch.h>
#include <setup.h>
#include <users.h>

using namespace vdrlive;


#line 1 "page_init.eh"

// do not add to Makefile
// and do not write a ecpp comment into this file. It must produce no
// html output not even an empty line.
#include <tnt/savepoint.h>
#include <exception.h>

#line 2 "page_exit.eh"

#include <exception.h>

// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    class searchtimer_actions_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        searchtimer_actions_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    searchtimer_actions_type searchtimer_actions;
};

static tnt::EcppComponentFactoryImpl<_component_> Factory("searchtimers");

static const char* rawData = "\304\000\000\000/\001\000\000:\001\000\000=\001\000\000\203\001\000\000\206\001\000\000,"
  "\002\000\000\372\002\000\000'\003\000\000T\003\000\000\222\003\000\000\272\003\000\000\274\003\000\000\306\003\000"
  "\000\325\003\000\000\353\003\000\000\005\004\000\000!\004\000\000;\004\000\000W\004\000\000q\004\000\000\224\004\000"
  "\000\277\004\000\000\331\004\000\000\340\004\000\000\342\004\000\000\n\005\000\0006\005\000\000B\005\000\000I\005\000"
  "\000K\005\000\000s\005\000\000\242\005\000\000\256\005\000\000\265\005\000\000\267\005\000\000\350\005\000\000\023"
  "\006\000\000<\006\000\000J\006\000\000Q\006\000\000S\006\000\000n\006\000\000\315\006\000\000\316\006\000\000\317\006"
  "\000\000\357\006\000\0009\007\000\000>\007\000\000\n<html>\n\t<head>\n<meta name=\"viewport\" content=\"width=device-"
  "width, initial-scale=1\" />\n\t\t<title>VDR-Live - </title>\n\t\t\n\t\t\n\t</head>\n\t<body onload=\"adjustHeader()\""
  " onresize=\"adjustHeader()\">\n\t\t\n\t\t\n\t\t<div class=\"inhalt\">\n\t\t\t<table class=\"listing\" cellspacing=\"0"
  "\" cellpadding=\"0\">\n\t\t\t\t<tr class=\"head\">\n\t\t\t\t\t<td colspan=\"8\">\n\t\t\t\t\t\t<div class=\"boxheader"
  "\"><div><div></div></div></div>\n\t\t\t\t\t</td>\n\t\t\t\t</tr>\n\t\t\t\t<tr class=\"description\">\n\t\t\t\t\t<td cl"
  "ass=\"action leftcol\"><img src=\"img/transparent.png\" alt=\"\" width=\"16px\" height=\"16px\"/></td>\n\t\t\t\t\t<td"
  "><div class=\"withmargin\"></div></td>\n\t\t\t\t\t<td><div class=\"withmargin\"></div></td>\n\t\t\t\t\t<td><div class"
  "=\"withmargin\"></div></td>\n\t\t\t\t\t<td class=\"rightcol\" colspan=\"4\"/>\n\t\t\t\t</tr>\n\t\t\t\t<tr>\n\t\t\t\t"
  "\t<td class=\"action leftcol \"><img src=\"\" alt=\"\"></img></td>\n\t\t\t\t\t<td class=\"\"><div class=\"withmargin"
  "\"></div></td>\n\t\t\t\t\t<td class=\"\"><div class=\"withmargin\"></div></td>\n\t\t\t\t\t<td class=\"\"><div class="
  "\"withmargin\"></div></td>\n\t\t\t\t\t<td class=\"action \"><a href=\"searchtimers.html\?searchtimerid=&action=toggle"
  "\"><img src=\"\" alt=\"\" ></img></a></td>\n\t\t\t\t\t<td class=\"action \"><a href=\"searchresults.html\?searchtimer"
  "id=\"><img src=\"\" alt=\"\" ></img></a></td>\n\t\t\t\t\t<td class=\"action \"><a href=\"edit_searchtimer.html\?searc"
  "htimerid=\"><img src=\"\" alt=\"\" ></img></a></td>\n\t\t\t\t\t<td class=\"action rightcol \"><a href=\"searchtimers."
  "html\?searchtimerid=&action=delete\" onclick=\"return confirm('')\"><img src=\"\" alt=\"\" ></img></a></td>\n\t\t\t\t"
  "</tr>\n\t\t\t\t<tr class=\"spacer\">\n\t\t\t\t\t<td colspan=\"8\"/>\n\t\t\t\t</tr>\n\t\t\t</table>\n\t\t</div>\n\t</b"
  "ody>\n</html>\n\n\n<a href=\"edit_searchtimer.html\"></a>\n<span class=\"sep\">|</span>\n<a href=\"searchtimers.html"
  "\?action=update\"></a>\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl),
    searchtimer_actions(*this, "searchtimer_actions")
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

template <typename T>
inline void _tnt_ignore_unused(const T&) { }

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("searchtimers " << qparam.getUrl());

  tnt::DataChunks _tntChunks(rawData);

  // <%args>
std::string searchtimerid = qparam.get< std::string >("searchtimerid");
std::string action = qparam.get< std::string >("action");
  // </%args>

#line 16 "searchtimers.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  // <%include> page_init.eh
#line 11 "page_init.eh"

try {
	reply.setHeader("Expires", "Mon, 26 Jul 1997 05:00:00 GMT");
	tnt::Savepoint spoint( reply );

  // </%include>
#line 19 "searchtimers.ecpp"

if (!logged_in && LiveSetup().UseAuth()) return reply.redirect("login.html");

#line 22 "searchtimers.ecpp"

	pageTitle = tr("Searchtimers");
	SearchTimers timers;
	if ( !searchtimerid.empty() ) {
		if (action == "toggle")
			timers.ToggleActive(searchtimerid);
		if (action == "delete") {
			if (!cUser::CurrentUserHasRightTo(UR_DELSTIMERS))
				throw HtmlError( tr("Sorry, no permission. Please contact your administrator!") );
			timers.Delete(searchtimerid);
		}
	}
	if (action == "update")
		timers.TriggerUpdate();

  // <& pageelems.doc_type ...
  { 
#line 37 "searchtimers.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 37 "searchtimers.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "doc_type"), request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << _tntChunks[0]; // \n<html>\n\t<head>\n<meta name="viewport" content="width=device-width, initial-scale=1" />\n\t\t<title>VDR-Live - 
#line 41 "searchtimers.ecpp"
  reply.sout() << ( pageTitle );
  reply.out() << _tntChunks[1]; // </title>\n\t\t
  // <& pageelems.stylesheets ...
  { 
#line 42 "searchtimers.ecpp"
    tnt::QueryParams _tnt_cq1;
#line 42 "searchtimers.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "stylesheets"), request, reply, _tnt_cq1);
    // &>
  }
  reply.out() << _tntChunks[2]; // \n\t\t
  // <& pageelems.ajax_js ...
  { 
#line 43 "searchtimers.ecpp"
    tnt::QueryParams _tnt_cq2;
#line 43 "searchtimers.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_js"), request, reply, _tnt_cq2);
    // &>
  }
  reply.out() << _tntChunks[3]; // \n\t</head>\n\t<body onload="adjustHeader()" onresize="adjustHeader()">\n\t\t
  // <& pageelems.logo ...
  { 
#line 46 "searchtimers.ecpp"
    tnt::QueryParams _tnt_cq3;
#line 46 "searchtimers.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "logo"), request, reply, _tnt_cq3);
    // &>
  }
  reply.out() << _tntChunks[4]; // \n\t\t
  // <& menu ...
  { 
#line 47 "searchtimers.ecpp"
    tnt::QueryParams _tnt_cq4;
#line 47 "searchtimers.ecpp"
    _tnt_cq4.add( "active", ("searchtimers"));
#line 47 "searchtimers.ecpp"
    _tnt_cq4.add( "component", ("searchtimers.searchtimer_actions"));
#line 47 "searchtimers.ecpp"
    callComp(tnt::Compident(std::string(), "menu"), request, reply, _tnt_cq4);
    // &>
  }
  reply.out() << _tntChunks[5]; // \n\t\t<div class="inhalt">\n\t\t\t<table class="listing" cellspacing="0" cellpadding="0">\n\t\t\t\t<tr class="head">\n\t\t\t\t\t<td colspan="8">\n\t\t\t\t\t\t<div class="boxheader"><div><div>
#line 52 "searchtimers.ecpp"
  reply.sout() << ( pageTitle );
  reply.out() << _tntChunks[6]; // </div></div></div>\n\t\t\t\t\t</td>\n\t\t\t\t</tr>\n\t\t\t\t<tr class="description">\n\t\t\t\t\t<td class="action leftcol"><img src="img/transparent.png" alt="" width="16px" height="16px"/></td>\n\t\t\t\t\t<td><div class="withmargin">
#line 57 "searchtimers.ecpp"
  reply.sout() << ( tr("Expression") );
  reply.out() << _tntChunks[7]; // </div></td>\n\t\t\t\t\t<td><div class="withmargin">
#line 58 "searchtimers.ecpp"
  reply.sout() << ( tr("Channel") );
  reply.out() << _tntChunks[8]; // </div></td>\n\t\t\t\t\t<td><div class="withmargin">
#line 59 "searchtimers.ecpp"
  reply.sout() << ( tr("Starts between") );
  reply.out() << _tntChunks[9]; // </div></td>\n\t\t\t\t\t<td class="rightcol" colspan="4"/>\n\t\t\t\t</tr>\n
#line 62 "searchtimers.ecpp"

				for (SearchTimers::iterator timer = timers.begin(); timer != timers.end(); ++timer) {
					SearchTimers::iterator nextTimer = timer; ++nextTimer;
					bool bottom = (nextTimer == timers.end());

  reply.out() << _tntChunks[10]; // \t\t\t\t<tr>\n\t\t\t\t\t<td class="action leftcol 
#line 68 "searchtimers.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << _tntChunks[11]; // ">
#line 68 "searchtimers.ecpp"
 if(timer->UseAsSearchTimer()) { 
  reply.out() << _tntChunks[12]; // <img src="
#line 68 "searchtimers.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "arrow.png") );
  reply.out() << _tntChunks[13]; // " alt=""></img>
#line 68 "searchtimers.ecpp"
 } 
  reply.out() << _tntChunks[14]; // </td>\n\t\t\t\t\t<td class="
#line 69 "searchtimers.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << _tntChunks[15]; // "><div class="withmargin">
#line 69 "searchtimers.ecpp"
  reply.sout() << ( timer->Search() );
  reply.out() << _tntChunks[16]; // </div></td>\n\t\t\t\t\t<td class="
#line 70 "searchtimers.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << _tntChunks[17]; // "><div class="withmargin">
#line 70 "searchtimers.ecpp"
  reply.sout() << ( timer->ChannelText() );
  reply.out() << _tntChunks[18]; // </div></td>\n\t\t\t\t\t<td class="
#line 71 "searchtimers.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << _tntChunks[19]; // "><div class="withmargin">
#line 71 "searchtimers.ecpp"
  if ( timer->UseTime() )
    reply.sout() <<  timer->StartTimeFormatted()+" - "+timer->StopTimeFormatted() ;
  reply.out() << _tntChunks[20]; // </div></td>\n\t\t\t\t\t<td class="action 
#line 72 "searchtimers.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << _tntChunks[21]; // "><a href="searchtimers.html\?searchtimerid=
#line 72 "searchtimers.ecpp"
  reply.sout() << ( timer->Id() );
  reply.out() << _tntChunks[22]; // &action=toggle"><img src="
#line 72 "searchtimers.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", timer->UseAsSearchTimer() ? "active.png" : "inactive.png") );
  reply.out() << _tntChunks[23]; // " alt="
#line 72 "searchtimers.ecpp"
  reply.sout() << ( tr("Toggle search timer actions (in)active") );
  reply.out() << _tntChunks[24]; // " 
  // <& tooltip.hint ...
  { 
#line 72 "searchtimers.ecpp"
    tnt::QueryParams _tnt_cq5;
#line 72 "searchtimers.ecpp"
    _tnt_cq5.add( "text", (tr("Toggle search timer actions (in)active")));
#line 72 "searchtimers.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq5);
    // &>
  }
  reply.out() << _tntChunks[25]; // ></img></a></td>\n\t\t\t\t\t<td class="action 
#line 73 "searchtimers.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << _tntChunks[26]; // "><a href="searchresults.html\?searchtimerid=
#line 73 "searchtimers.ecpp"
  reply.sout() << ( timer->Id() );
  reply.out() << _tntChunks[27]; // "><img src="
#line 73 "searchtimers.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "search.png") );
  reply.out() << _tntChunks[28]; // " alt="
#line 73 "searchtimers.ecpp"
  reply.sout() << ( tr("Browse search timer results") );
  reply.out() << _tntChunks[29]; // " 
  // <& tooltip.hint ...
  { 
#line 73 "searchtimers.ecpp"
    tnt::QueryParams _tnt_cq6;
#line 73 "searchtimers.ecpp"
    _tnt_cq6.add( "text", (tr("Browse search timer results")));
#line 73 "searchtimers.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq6);
    // &>
  }
  reply.out() << _tntChunks[30]; // ></img></a></td>\n\t\t\t\t\t<td class="action 
#line 74 "searchtimers.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << _tntChunks[31]; // "><a href="edit_searchtimer.html\?searchtimerid=
#line 74 "searchtimers.ecpp"
  reply.sout() << ( timer->Id() );
  reply.out() << _tntChunks[32]; // "><img src="
#line 74 "searchtimers.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "edit.png") );
  reply.out() << _tntChunks[33]; // " alt="
#line 74 "searchtimers.ecpp"
  reply.sout() << ( tr("Edit search timer") );
  reply.out() << _tntChunks[34]; // " 
  // <& tooltip.hint ...
  { 
#line 74 "searchtimers.ecpp"
    tnt::QueryParams _tnt_cq7;
#line 74 "searchtimers.ecpp"
    _tnt_cq7.add( "text", (tr("Edit search timer")));
#line 74 "searchtimers.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq7);
    // &>
  }
  reply.out() << _tntChunks[35]; // ></img></a></td>\n\t\t\t\t\t<td class="action rightcol 
#line 75 "searchtimers.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << _tntChunks[36]; // "><a href="searchtimers.html\?searchtimerid=
#line 75 "searchtimers.ecpp"
  reply.sout() << ( timer->Id() );
  reply.out() << _tntChunks[37]; // &action=delete" onclick="return confirm('
#line 75 "searchtimers.ecpp"
  reply.sout() << ( tr("Delete this search timer?") );
  reply.out() << _tntChunks[38]; // ')"><img src="
#line 75 "searchtimers.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "del.png") );
  reply.out() << _tntChunks[39]; // " alt="
#line 75 "searchtimers.ecpp"
  reply.sout() << ( tr("Delete search timer") );
  reply.out() << _tntChunks[40]; // " 
  // <& tooltip.hint ...
  { 
#line 75 "searchtimers.ecpp"
    tnt::QueryParams _tnt_cq8;
#line 75 "searchtimers.ecpp"
    _tnt_cq8.add( "text", (tr("Delete search timer")));
#line 75 "searchtimers.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq8);
    // &>
  }
  reply.out() << _tntChunks[41]; // ></img></a></td>\n\t\t\t\t</tr>\n
#line 77 "searchtimers.ecpp"

				}

  reply.out() << _tntChunks[42]; // \t\t\t\t<tr class="spacer">\n\t\t\t\t\t<td colspan="8"/>\n\t\t\t\t</tr>\n\t\t\t</table>\n\t\t</div>\n\t</body>\n</html>\n
  // <%include> page_exit.eh
  reply.out() << _tntChunks[43]; // \n
#line 5 "page_exit.eh"

	spoint.commit();
} catch ( vdrlive::HtmlError const& ex ) {
	tnt::QueryParams param = qparam;
	param.add( "pageTitle", pageTitle );
	param.add( "errorMessage", ex.what() );
	callComp( "error", request, reply, param );
}

  // </%include>
  reply.out() << _tntChunks[44]; // \n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::searchtimer_actions_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("searchtimers::searchtimer_actions " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 16 "searchtimers.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  reply.out() << _tntChunks[45]; // <a href="edit_searchtimer.html">
#line 90 "searchtimers.ecpp"
  reply.sout() << ( tr("New search timer") );
  reply.out() << _tntChunks[46]; // </a>\n<span class="sep">|</span>\n<a href="searchtimers.html\?action=update">
#line 92 "searchtimers.ecpp"
  reply.sout() << ( tr("Trigger search timer update") );
  reply.out() << _tntChunks[47]; // </a>\n
  // <%/cpp>
  return DEFAULT;
}

} // namespace
